// Code generated by https://github.com/gagliardetto/anchor-go. DO NOT EDIT.

package khronos

import (
	"errors"
	ag_binary "github.com/gagliardetto/binary"
	ag_solanago "github.com/gagliardetto/solana-go"
	ag_format "github.com/gagliardetto/solana-go/text/format"
	ag_treeout "github.com/gagliardetto/treeout"
)

// Swap is the `swap` instruction.
type Swap struct {

	// [0] = [WRITE] depositAccount
	//
	// [1] = [WRITE] destinationAccount
	//
	// [2] = [] vaultAuthority
	//
	// [3] = [WRITE] vault
	//
	// ····· marketAccs: [4] = [WRITE] market
	//
	// ················· [5] = [WRITE] ammId
	//
	// ················· [6] = [] ammAuthority
	//
	// ················· [7] = [WRITE] ammOpenOrders
	//
	// ················· [8] = [WRITE] ammTargetOrders
	//
	// ················· [9] = [WRITE] poolCoinTokenAccount
	//
	// ················· [10] = [WRITE] poolPcTokenAccount
	//
	// ················· [11] = [WRITE] requestQueue
	//
	// ················· [12] = [WRITE] eventQueue
	//
	// ················· [13] = [WRITE] bids
	//
	// ················· [14] = [WRITE] asks
	//
	// ················· [15] = [WRITE] poolCoinVault
	//
	// ················· [16] = [WRITE] poolPcVault
	//
	// ················· [17] = [] poolVaultSigner
	//
	// [18] = [] dexProgram
	//
	// [19] = [] swapProgram
	//
	// [20] = [] tokenProgram
	ag_solanago.AccountMetaSlice `bin:"-"`
}

// NewSwapInstructionBuilder creates a new `Swap` instruction builder.
func NewSwapInstructionBuilder() *Swap {
	nd := &Swap{
		AccountMetaSlice: make(ag_solanago.AccountMetaSlice, 21),
	}
	return nd
}

// SetDepositAccountAccount sets the "depositAccount" account.
func (inst *Swap) SetDepositAccountAccount(depositAccount ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[0] = ag_solanago.Meta(depositAccount).WRITE()
	return inst
}

// GetDepositAccountAccount gets the "depositAccount" account.
func (inst *Swap) GetDepositAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(0)
}

// SetDestinationAccountAccount sets the "destinationAccount" account.
func (inst *Swap) SetDestinationAccountAccount(destinationAccount ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[1] = ag_solanago.Meta(destinationAccount).WRITE()
	return inst
}

// GetDestinationAccountAccount gets the "destinationAccount" account.
func (inst *Swap) GetDestinationAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(1)
}

// SetVaultAuthorityAccount sets the "vaultAuthority" account.
func (inst *Swap) SetVaultAuthorityAccount(vaultAuthority ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[2] = ag_solanago.Meta(vaultAuthority)
	return inst
}

// GetVaultAuthorityAccount gets the "vaultAuthority" account.
func (inst *Swap) GetVaultAuthorityAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(2)
}

// SetVaultAccount sets the "vault" account.
func (inst *Swap) SetVaultAccount(vault ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[3] = ag_solanago.Meta(vault).WRITE()
	return inst
}

// GetVaultAccount gets the "vault" account.
func (inst *Swap) GetVaultAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(3)
}

type SwapMarketAccsAccountsBuilder struct {
	ag_solanago.AccountMetaSlice `bin:"-"`
}

func NewSwapMarketAccsAccountsBuilder() *SwapMarketAccsAccountsBuilder {
	return &SwapMarketAccsAccountsBuilder{
		AccountMetaSlice: make(ag_solanago.AccountMetaSlice, 14),
	}
}

func (inst *Swap) SetMarketAccsAccountsFromBuilder(swapMarketAccsAccountsBuilder *SwapMarketAccsAccountsBuilder) *Swap {
	inst.AccountMetaSlice[4] = swapMarketAccsAccountsBuilder.GetMarketAccount()
	inst.AccountMetaSlice[5] = swapMarketAccsAccountsBuilder.GetAmmIdAccount()
	inst.AccountMetaSlice[6] = swapMarketAccsAccountsBuilder.GetAmmAuthorityAccount()
	inst.AccountMetaSlice[7] = swapMarketAccsAccountsBuilder.GetAmmOpenOrdersAccount()
	inst.AccountMetaSlice[8] = swapMarketAccsAccountsBuilder.GetAmmTargetOrdersAccount()
	inst.AccountMetaSlice[9] = swapMarketAccsAccountsBuilder.GetPoolCoinTokenAccountAccount()
	inst.AccountMetaSlice[10] = swapMarketAccsAccountsBuilder.GetPoolPcTokenAccountAccount()
	inst.AccountMetaSlice[11] = swapMarketAccsAccountsBuilder.GetRequestQueueAccount()
	inst.AccountMetaSlice[12] = swapMarketAccsAccountsBuilder.GetEventQueueAccount()
	inst.AccountMetaSlice[13] = swapMarketAccsAccountsBuilder.GetBidsAccount()
	inst.AccountMetaSlice[14] = swapMarketAccsAccountsBuilder.GetAsksAccount()
	inst.AccountMetaSlice[15] = swapMarketAccsAccountsBuilder.GetPoolCoinVaultAccount()
	inst.AccountMetaSlice[16] = swapMarketAccsAccountsBuilder.GetPoolPcVaultAccount()
	inst.AccountMetaSlice[17] = swapMarketAccsAccountsBuilder.GetPoolVaultSignerAccount()
	return inst
}

// SetMarketAccount sets the "market" account.
func (inst *SwapMarketAccsAccountsBuilder) SetMarketAccount(market ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[0] = ag_solanago.Meta(market).WRITE()
	return inst
}

// GetMarketAccount gets the "market" account.
func (inst *SwapMarketAccsAccountsBuilder) GetMarketAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(0)
}

// SetAmmIdAccount sets the "ammId" account.
func (inst *SwapMarketAccsAccountsBuilder) SetAmmIdAccount(ammId ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[1] = ag_solanago.Meta(ammId).WRITE()
	return inst
}

// GetAmmIdAccount gets the "ammId" account.
func (inst *SwapMarketAccsAccountsBuilder) GetAmmIdAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(1)
}

// SetAmmAuthorityAccount sets the "ammAuthority" account.
func (inst *SwapMarketAccsAccountsBuilder) SetAmmAuthorityAccount(ammAuthority ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[2] = ag_solanago.Meta(ammAuthority)
	return inst
}

// GetAmmAuthorityAccount gets the "ammAuthority" account.
func (inst *SwapMarketAccsAccountsBuilder) GetAmmAuthorityAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(2)
}

// SetAmmOpenOrdersAccount sets the "ammOpenOrders" account.
func (inst *SwapMarketAccsAccountsBuilder) SetAmmOpenOrdersAccount(ammOpenOrders ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[3] = ag_solanago.Meta(ammOpenOrders).WRITE()
	return inst
}

// GetAmmOpenOrdersAccount gets the "ammOpenOrders" account.
func (inst *SwapMarketAccsAccountsBuilder) GetAmmOpenOrdersAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(3)
}

// SetAmmTargetOrdersAccount sets the "ammTargetOrders" account.
func (inst *SwapMarketAccsAccountsBuilder) SetAmmTargetOrdersAccount(ammTargetOrders ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[4] = ag_solanago.Meta(ammTargetOrders).WRITE()
	return inst
}

// GetAmmTargetOrdersAccount gets the "ammTargetOrders" account.
func (inst *SwapMarketAccsAccountsBuilder) GetAmmTargetOrdersAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(4)
}

// SetPoolCoinTokenAccountAccount sets the "poolCoinTokenAccount" account.
func (inst *SwapMarketAccsAccountsBuilder) SetPoolCoinTokenAccountAccount(poolCoinTokenAccount ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[5] = ag_solanago.Meta(poolCoinTokenAccount).WRITE()
	return inst
}

// GetPoolCoinTokenAccountAccount gets the "poolCoinTokenAccount" account.
func (inst *SwapMarketAccsAccountsBuilder) GetPoolCoinTokenAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(5)
}

// SetPoolPcTokenAccountAccount sets the "poolPcTokenAccount" account.
func (inst *SwapMarketAccsAccountsBuilder) SetPoolPcTokenAccountAccount(poolPcTokenAccount ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[6] = ag_solanago.Meta(poolPcTokenAccount).WRITE()
	return inst
}

// GetPoolPcTokenAccountAccount gets the "poolPcTokenAccount" account.
func (inst *SwapMarketAccsAccountsBuilder) GetPoolPcTokenAccountAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(6)
}

// SetRequestQueueAccount sets the "requestQueue" account.
func (inst *SwapMarketAccsAccountsBuilder) SetRequestQueueAccount(requestQueue ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[7] = ag_solanago.Meta(requestQueue).WRITE()
	return inst
}

// GetRequestQueueAccount gets the "requestQueue" account.
func (inst *SwapMarketAccsAccountsBuilder) GetRequestQueueAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(7)
}

// SetEventQueueAccount sets the "eventQueue" account.
func (inst *SwapMarketAccsAccountsBuilder) SetEventQueueAccount(eventQueue ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[8] = ag_solanago.Meta(eventQueue).WRITE()
	return inst
}

// GetEventQueueAccount gets the "eventQueue" account.
func (inst *SwapMarketAccsAccountsBuilder) GetEventQueueAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(8)
}

// SetBidsAccount sets the "bids" account.
func (inst *SwapMarketAccsAccountsBuilder) SetBidsAccount(bids ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[9] = ag_solanago.Meta(bids).WRITE()
	return inst
}

// GetBidsAccount gets the "bids" account.
func (inst *SwapMarketAccsAccountsBuilder) GetBidsAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(9)
}

// SetAsksAccount sets the "asks" account.
func (inst *SwapMarketAccsAccountsBuilder) SetAsksAccount(asks ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[10] = ag_solanago.Meta(asks).WRITE()
	return inst
}

// GetAsksAccount gets the "asks" account.
func (inst *SwapMarketAccsAccountsBuilder) GetAsksAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(10)
}

// SetPoolCoinVaultAccount sets the "poolCoinVault" account.
func (inst *SwapMarketAccsAccountsBuilder) SetPoolCoinVaultAccount(poolCoinVault ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[11] = ag_solanago.Meta(poolCoinVault).WRITE()
	return inst
}

// GetPoolCoinVaultAccount gets the "poolCoinVault" account.
func (inst *SwapMarketAccsAccountsBuilder) GetPoolCoinVaultAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(11)
}

// SetPoolPcVaultAccount sets the "poolPcVault" account.
func (inst *SwapMarketAccsAccountsBuilder) SetPoolPcVaultAccount(poolPcVault ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[12] = ag_solanago.Meta(poolPcVault).WRITE()
	return inst
}

// GetPoolPcVaultAccount gets the "poolPcVault" account.
func (inst *SwapMarketAccsAccountsBuilder) GetPoolPcVaultAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(12)
}

// SetPoolVaultSignerAccount sets the "poolVaultSigner" account.
func (inst *SwapMarketAccsAccountsBuilder) SetPoolVaultSignerAccount(poolVaultSigner ag_solanago.PublicKey) *SwapMarketAccsAccountsBuilder {
	inst.AccountMetaSlice[13] = ag_solanago.Meta(poolVaultSigner)
	return inst
}

// GetPoolVaultSignerAccount gets the "poolVaultSigner" account.
func (inst *SwapMarketAccsAccountsBuilder) GetPoolVaultSignerAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(13)
}

// SetDexProgramAccount sets the "dexProgram" account.
func (inst *Swap) SetDexProgramAccount(dexProgram ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[18] = ag_solanago.Meta(dexProgram)
	return inst
}

// GetDexProgramAccount gets the "dexProgram" account.
func (inst *Swap) GetDexProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(18)
}

// SetSwapProgramAccount sets the "swapProgram" account.
func (inst *Swap) SetSwapProgramAccount(swapProgram ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[19] = ag_solanago.Meta(swapProgram)
	return inst
}

// GetSwapProgramAccount gets the "swapProgram" account.
func (inst *Swap) GetSwapProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(19)
}

// SetTokenProgramAccount sets the "tokenProgram" account.
func (inst *Swap) SetTokenProgramAccount(tokenProgram ag_solanago.PublicKey) *Swap {
	inst.AccountMetaSlice[20] = ag_solanago.Meta(tokenProgram)
	return inst
}

// GetTokenProgramAccount gets the "tokenProgram" account.
func (inst *Swap) GetTokenProgramAccount() *ag_solanago.AccountMeta {
	return inst.AccountMetaSlice.Get(20)
}

func (inst Swap) Build() *Instruction {
	return &Instruction{BaseVariant: ag_binary.BaseVariant{
		Impl:   inst,
		TypeID: Instruction_Swap,
	}}
}

// ValidateAndBuild validates the instruction parameters and accounts;
// if there is a validation error, it returns the error.
// Otherwise, it builds and returns the instruction.
func (inst Swap) ValidateAndBuild() (*Instruction, error) {
	if err := inst.Validate(); err != nil {
		return nil, err
	}
	return inst.Build(), nil
}

func (inst *Swap) Validate() error {
	// Check whether all (required) accounts are set:
	{
		if inst.AccountMetaSlice[0] == nil {
			return errors.New("accounts.DepositAccount is not set")
		}
		if inst.AccountMetaSlice[1] == nil {
			return errors.New("accounts.DestinationAccount is not set")
		}
		if inst.AccountMetaSlice[2] == nil {
			return errors.New("accounts.VaultAuthority is not set")
		}
		if inst.AccountMetaSlice[3] == nil {
			return errors.New("accounts.Vault is not set")
		}
		if inst.AccountMetaSlice[4] == nil {
			return errors.New("accounts.MarketAccsMarket is not set")
		}
		if inst.AccountMetaSlice[5] == nil {
			return errors.New("accounts.MarketAccsAmmId is not set")
		}
		if inst.AccountMetaSlice[6] == nil {
			return errors.New("accounts.MarketAccsAmmAuthority is not set")
		}
		if inst.AccountMetaSlice[7] == nil {
			return errors.New("accounts.MarketAccsAmmOpenOrders is not set")
		}
		if inst.AccountMetaSlice[8] == nil {
			return errors.New("accounts.MarketAccsAmmTargetOrders is not set")
		}
		if inst.AccountMetaSlice[9] == nil {
			return errors.New("accounts.MarketAccsPoolCoinTokenAccount is not set")
		}
		if inst.AccountMetaSlice[10] == nil {
			return errors.New("accounts.MarketAccsPoolPcTokenAccount is not set")
		}
		if inst.AccountMetaSlice[11] == nil {
			return errors.New("accounts.MarketAccsRequestQueue is not set")
		}
		if inst.AccountMetaSlice[12] == nil {
			return errors.New("accounts.MarketAccsEventQueue is not set")
		}
		if inst.AccountMetaSlice[13] == nil {
			return errors.New("accounts.MarketAccsBids is not set")
		}
		if inst.AccountMetaSlice[14] == nil {
			return errors.New("accounts.MarketAccsAsks is not set")
		}
		if inst.AccountMetaSlice[15] == nil {
			return errors.New("accounts.MarketAccsPoolCoinVault is not set")
		}
		if inst.AccountMetaSlice[16] == nil {
			return errors.New("accounts.MarketAccsPoolPcVault is not set")
		}
		if inst.AccountMetaSlice[17] == nil {
			return errors.New("accounts.MarketAccsPoolVaultSigner is not set")
		}
		if inst.AccountMetaSlice[18] == nil {
			return errors.New("accounts.DexProgram is not set")
		}
		if inst.AccountMetaSlice[19] == nil {
			return errors.New("accounts.SwapProgram is not set")
		}
		if inst.AccountMetaSlice[20] == nil {
			return errors.New("accounts.TokenProgram is not set")
		}
	}
	return nil
}

func (inst *Swap) EncodeToTree(parent ag_treeout.Branches) {
	parent.Child(ag_format.Program(ProgramName, ProgramID)).
		//
		ParentFunc(func(programBranch ag_treeout.Branches) {
			programBranch.Child(ag_format.Instruction("Swap")).
				//
				ParentFunc(func(instructionBranch ag_treeout.Branches) {

					// Parameters of the instruction:
					instructionBranch.Child("Params[len=0]").ParentFunc(func(paramsBranch ag_treeout.Branches) {})

					// Accounts of the instruction:
					instructionBranch.Child("Accounts[len=21]").ParentFunc(func(accountsBranch ag_treeout.Branches) {
						accountsBranch.Child(ag_format.Meta("                   deposit", inst.AccountMetaSlice.Get(0)))
						accountsBranch.Child(ag_format.Meta("               destination", inst.AccountMetaSlice.Get(1)))
						accountsBranch.Child(ag_format.Meta("            vaultAuthority", inst.AccountMetaSlice.Get(2)))
						accountsBranch.Child(ag_format.Meta("                     vault", inst.AccountMetaSlice.Get(3)))
						accountsBranch.Child(ag_format.Meta("         marketAccs\\market", inst.AccountMetaSlice.Get(4)))
						accountsBranch.Child(ag_format.Meta("          marketAccs\\ammId", inst.AccountMetaSlice.Get(5)))
						accountsBranch.Child(ag_format.Meta("   marketAccs\\ammAuthority", inst.AccountMetaSlice.Get(6)))
						accountsBranch.Child(ag_format.Meta("  marketAccs\\ammOpenOrders", inst.AccountMetaSlice.Get(7)))
						accountsBranch.Child(ag_format.Meta("marketAccs\\ammTargetOrders", inst.AccountMetaSlice.Get(8)))
						accountsBranch.Child(ag_format.Meta("  marketAccs\\poolCoinToken", inst.AccountMetaSlice.Get(9)))
						accountsBranch.Child(ag_format.Meta("    marketAccs\\poolPcToken", inst.AccountMetaSlice.Get(10)))
						accountsBranch.Child(ag_format.Meta("   marketAccs\\requestQueue", inst.AccountMetaSlice.Get(11)))
						accountsBranch.Child(ag_format.Meta("     marketAccs\\eventQueue", inst.AccountMetaSlice.Get(12)))
						accountsBranch.Child(ag_format.Meta("           marketAccs\\bids", inst.AccountMetaSlice.Get(13)))
						accountsBranch.Child(ag_format.Meta("           marketAccs\\asks", inst.AccountMetaSlice.Get(14)))
						accountsBranch.Child(ag_format.Meta("  marketAccs\\poolCoinVault", inst.AccountMetaSlice.Get(15)))
						accountsBranch.Child(ag_format.Meta("    marketAccs\\poolPcVault", inst.AccountMetaSlice.Get(16)))
						accountsBranch.Child(ag_format.Meta("marketAccs\\poolVaultSigner", inst.AccountMetaSlice.Get(17)))
						accountsBranch.Child(ag_format.Meta("                dexProgram", inst.AccountMetaSlice.Get(18)))
						accountsBranch.Child(ag_format.Meta("               swapProgram", inst.AccountMetaSlice.Get(19)))
						accountsBranch.Child(ag_format.Meta("              tokenProgram", inst.AccountMetaSlice.Get(20)))
					})
				})
		})
}

func (obj Swap) MarshalWithEncoder(encoder *ag_binary.Encoder) (err error) {
	return nil
}
func (obj *Swap) UnmarshalWithDecoder(decoder *ag_binary.Decoder) (err error) {
	return nil
}

// NewSwapInstruction declares a new Swap instruction with the provided parameters and accounts.
func NewSwapInstruction(
	// Accounts:
	depositAccount ag_solanago.PublicKey,
	destinationAccount ag_solanago.PublicKey,
	vaultAuthority ag_solanago.PublicKey,
	vault ag_solanago.PublicKey,
	marketAccsMarket ag_solanago.PublicKey,
	marketAccsAmmId ag_solanago.PublicKey,
	marketAccsAmmAuthority ag_solanago.PublicKey,
	marketAccsAmmOpenOrders ag_solanago.PublicKey,
	marketAccsAmmTargetOrders ag_solanago.PublicKey,
	marketAccsPoolCoinTokenAccount ag_solanago.PublicKey,
	marketAccsPoolPcTokenAccount ag_solanago.PublicKey,
	marketAccsRequestQueue ag_solanago.PublicKey,
	marketAccsEventQueue ag_solanago.PublicKey,
	marketAccsBids ag_solanago.PublicKey,
	marketAccsAsks ag_solanago.PublicKey,
	marketAccsPoolCoinVault ag_solanago.PublicKey,
	marketAccsPoolPcVault ag_solanago.PublicKey,
	marketAccsPoolVaultSigner ag_solanago.PublicKey,
	dexProgram ag_solanago.PublicKey,
	swapProgram ag_solanago.PublicKey,
	tokenProgram ag_solanago.PublicKey) *Swap {
	return NewSwapInstructionBuilder().
		SetDepositAccountAccount(depositAccount).
		SetDestinationAccountAccount(destinationAccount).
		SetVaultAuthorityAccount(vaultAuthority).
		SetVaultAccount(vault).
		SetMarketAccsAccountsFromBuilder(
			NewSwapMarketAccsAccountsBuilder().
				SetMarketAccount(marketAccsMarket).
				SetAmmIdAccount(marketAccsAmmId).
				SetAmmAuthorityAccount(marketAccsAmmAuthority).
				SetAmmOpenOrdersAccount(marketAccsAmmOpenOrders).
				SetAmmTargetOrdersAccount(marketAccsAmmTargetOrders).
				SetPoolCoinTokenAccountAccount(marketAccsPoolCoinTokenAccount).
				SetPoolPcTokenAccountAccount(marketAccsPoolPcTokenAccount).
				SetRequestQueueAccount(marketAccsRequestQueue).
				SetEventQueueAccount(marketAccsEventQueue).
				SetBidsAccount(marketAccsBids).
				SetAsksAccount(marketAccsAsks).
				SetPoolCoinVaultAccount(marketAccsPoolCoinVault).
				SetPoolPcVaultAccount(marketAccsPoolPcVault).
				SetPoolVaultSignerAccount(marketAccsPoolVaultSigner),
		).
		SetDexProgramAccount(dexProgram).
		SetSwapProgramAccount(swapProgram).
		SetTokenProgramAccount(tokenProgram)
}
